using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.IO;

namespace TypedDataSet
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		string commandText = "SELECT *  FROM TOUR";
		string commandText2 = "SELECT*  FROM SEASON";
		string commandText3 = "SELECT*  FROM PASS";
		string commandText4 = "SELECT*  FROM PAYMENT";
		private TypedDataSet.XSDTour_bd dsTour;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.RichTextBox richTextBox1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuFill;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuOpen;
		private System.Windows.Forms.MenuItem mnuAuto;
		private System.Windows.Forms.MenuItem mnuDiffGram;
		private System.Windows.Forms.MenuItem mnuFragment;
		private System.Windows.Forms.MenuItem mnuIgnoreSchema;
		private System.Windows.Forms.MenuItem mnuInferSchema;
		private System.Windows.Forms.MenuItem mnuReadSchema;
		private System.Windows.Forms.MenuItem mnuReadXmlSchema;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		string connectionString = @"Provider=""Microsoft.Jet.OLEDB.4.0"";Data Source=""D:\Uchebnik\Code\Glava5\BDTur_firm_Eng.mdb"";User ID=Admin;Jet OLEDB:Encrypt Database=False";
	

		public Form1()
		{
			InitializeComponent();
			//
			this.mnuDiffGram.Click += new EventHandler(mnuAuto_Click);
			this.mnuFragment.Click += new EventHandler(mnuAuto_Click);
			this.mnuIgnoreSchema.Click += new EventHandler(mnuAuto_Click);
			this.mnuInferSchema.Click += new EventHandler(mnuAuto_Click);
			this.mnuReadSchema.Click += new EventHandler(mnuAuto_Click);
			
		}

		private void ClearForm()
		{
			dsTour.Clear();
			dataGrid1.DataSource = null;
			richTextBox1.Text = "";
		}

		private void StructureDataSet()
		{
			richTextBox1.Text+= ("  DataSet." + dsTour.DataSetName);

			//  
			richTextBox1.Text+= ("\n : "+dsTour.Tables.Count.ToString());
			richTextBox1.Text+= ("\n : "+dsTour.Relations.Count.ToString());
			
			//    
			for(int i=0;i<dsTour.Tables.Count;i++)
			{
				//  
				richTextBox1.Text+=( "\n"+"\n : "+dsTour.Tables[i].TableName.ToString());
				richTextBox1.Text+=("  "+dsTour.Tables[i].Columns.Count.ToString() +" "+"\n");
			
				for(int j=0;j<dsTour.Tables[i].Columns.Count;j++)
				{
					//     
					richTextBox1.Text+=("\n: "+ dsTour.Tables[i].Columns[j].ColumnName.ToString()+ "  : "+ dsTour.Tables[i].Columns[j].DataType);
				}
			}
			for(int k = 0; k<dsTour.Relations.Count; k++)
			{				
				richTextBox1.Text+= ("\n"+"\n : "
					+dsTour.Relations[k].ParentTable+ " --- : " +dsTour.Relations[k].ParentKeyConstraint
					+" ---   : " +dsTour.Relations[k].ChildTable);
			}
		}

  
		

	
	

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsTour = new TypedDataSet.XSDTour_bd();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFill = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuOpen = new System.Windows.Forms.MenuItem();
			this.mnuAuto = new System.Windows.Forms.MenuItem();
			this.mnuDiffGram = new System.Windows.Forms.MenuItem();
			this.mnuFragment = new System.Windows.Forms.MenuItem();
			this.mnuIgnoreSchema = new System.Windows.Forms.MenuItem();
			this.mnuInferSchema = new System.Windows.Forms.MenuItem();
			this.mnuReadSchema = new System.Windows.Forms.MenuItem();
			this.mnuReadXmlSchema = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			((System.ComponentModel.ISupportInitialize)(this.dsTour)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dsTour
			// 
			this.dsTour.DataSetName = "XSDTour_bd";
			this.dsTour.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Left;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 0);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(130, 266);
			this.dataGrid1.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(130, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 266);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// richTextBox1
			// 
			this.richTextBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.richTextBox1.Location = new System.Drawing.Point(133, 0);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(159, 266);
			this.richTextBox1.TabIndex = 2;
			this.richTextBox1.Text = "";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFill,
																					this.menuItem1,
																					this.mnuOpen,
																					this.mnuReadXmlSchema});
			this.mnuFile.Text = "&";
			// 
			// mnuFill
			// 
			this.mnuFill.Index = 0;
			this.mnuFill.Text = "&";
			this.mnuFill.Click += new System.EventHandler(this.mnuFill_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.Text = "-";
			// 
			// mnuOpen
			// 
			this.mnuOpen.Index = 2;
			this.mnuOpen.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuAuto,
																					this.mnuDiffGram,
																					this.mnuFragment,
																					this.mnuIgnoreSchema,
																					this.mnuInferSchema,
																					this.mnuReadSchema});
			this.mnuOpen.Text = "&";
			// 
			// mnuAuto
			// 
			this.mnuAuto.Index = 0;
			this.mnuAuto.Text = "&Auto";
			this.mnuAuto.Click += new System.EventHandler(this.mnuAuto_Click);
			// 
			// mnuDiffGram
			// 
			this.mnuDiffGram.Index = 1;
			this.mnuDiffGram.Text = "&DiffGram";
			// 
			// mnuFragment
			// 
			this.mnuFragment.Index = 2;
			this.mnuFragment.Text = "&Fragment";
			// 
			// mnuIgnoreSchema
			// 
			this.mnuIgnoreSchema.Index = 3;
			this.mnuIgnoreSchema.Text = "I&gnore Schema";
			// 
			// mnuInferSchema
			// 
			this.mnuInferSchema.Index = 4;
			this.mnuInferSchema.Text = "&Infer Schema";
			// 
			// mnuReadSchema
			// 
			this.mnuReadSchema.Index = 5;
			this.mnuReadSchema.Text = "&Read Schema";
			// 
			// mnuReadXmlSchema
			// 
			this.mnuReadXmlSchema.Index = 3;
			this.mnuReadXmlSchema.Text = " &";
			this.mnuReadXmlSchema.Click += new System.EventHandler(this.mnuReadXmlSchema_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "XML and XSD Files(*.xml, *.xsd)| *.xml; *.xsd; |All Files(*.*)|*.*";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.richTextBox1);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.dataGrid1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dsTour)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void mnuFill_Click(object sender, System.EventArgs e)
		{
			ClearForm();

			OleDbConnection conn = new OleDbConnection(connectionString);
			OleDbCommand myCommand = new OleDbCommand();
			myCommand.Connection = conn;
			myCommand.CommandText = commandText;
			OleDbDataAdapter dataAdapter = new OleDbDataAdapter();
			dataAdapter.SelectCommand = myCommand;
					
			dataAdapter.TableMappings.Add("Table", "TOUR");
					
			OleDbCommand myCommand2 = new OleDbCommand();
			myCommand2.Connection = conn;
			myCommand2.CommandText = commandText2;
			OleDbDataAdapter dataAdapter2 = new OleDbDataAdapter();
			dataAdapter2.SelectCommand = myCommand2;
			dataAdapter2.TableMappings.Add("Table", "SEASON");

			OleDbCommand myCommand3 = new OleDbCommand();
			myCommand3.Connection = conn;
			myCommand3.CommandText = commandText3;
			OleDbDataAdapter dataAdapter3 = new OleDbDataAdapter();
			dataAdapter3.SelectCommand = myCommand3;
			dataAdapter3.TableMappings.Add("Table", "PASS");

			OleDbCommand myCommand4 = new OleDbCommand();
			myCommand4.Connection = conn;
			myCommand4.CommandText = commandText4;
			OleDbDataAdapter dataAdapter4 = new OleDbDataAdapter();
			dataAdapter4.SelectCommand = myCommand4;
			dataAdapter4.TableMappings.Add("Table", "PAYMENT");

			conn.Open();
			dataAdapter.Fill(dsTour);
			dataAdapter2.Fill(dsTour);
			dataAdapter3.Fill(dsTour);
			dataAdapter4.Fill(dsTour);
			conn.Close();
			dataGrid1.DataSource = dsTour;
			StructureDataSet();
		}

		private void mnuAuto_Click(object sender, System.EventArgs e)
		{
			ClearForm();

			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				XmlReadMode readMode = XmlReadMode.Auto;
				MenuItem menuItem = (MenuItem)sender;
				switch(menuItem.Index)
				{
					case 0:
						readMode = XmlReadMode.Auto;
						break;
					case 1:
						readMode = XmlReadMode.DiffGram;
						break;
					case 2:
						readMode = XmlReadMode.Fragment;
						break;
					case 3:
						readMode = XmlReadMode.IgnoreSchema;
						break;
					case 4:
						readMode = XmlReadMode.InferSchema;
						break;
					case 5:
						readMode = XmlReadMode.ReadSchema;
						break;
				}

				dsTour.ReadXml(openFileDialog1.FileName, readMode);
				dataGrid1.DataSource = dsTour;
				//     richTextBox1
				FileStream filestream= File.Open(openFileDialog1.FileName, FileMode.Open, FileAccess.Read);
				//,    ,    ,  
				if(filestream != null)
				{
					//  streamreader      filestream
					StreamReader streamreader = new StreamReader(filestream);
					//       TextBox
					richTextBox1.Text = streamreader.ReadToEnd();
					
					// .
					filestream.Close();
				}
			}
		}

		private void mnuReadXmlSchema_Click(object sender, System.EventArgs e)
		{
			ClearForm();
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				dsTour.ReadXmlSchema(openFileDialog1.FileName);
				dataGrid1.DataSource = dsTour;
				FileStream filestream= File.Open(openFileDialog1.FileName, FileMode.Open, FileAccess.Read);
				//,    ,    ,  
				if(filestream != null)
				{
					//  streamreader      filestream
					StreamReader streamreader = new StreamReader(filestream);
					//       TextBox
					richTextBox1.Text = streamreader.ReadToEnd();
					
					// .
					filestream.Close();
				}
			}
			
		}
	}
}
